Merge tag 'for-linux-6.12-ofs1' of git://git.kernel.org/pub/scm/linux/kernel/git...
[linux-2.6-block.git] / scripts / faddr2line
1 #!/bin/bash
2 # SPDX-License-Identifier: GPL-2.0
3 #
4 # Translate stack dump function offsets.
5 #
6 # addr2line doesn't work with KASLR addresses.  This works similarly to
7 # addr2line, but instead takes the 'func+0x123' format as input:
8 #
9 #   $ ./scripts/faddr2line ~/k/vmlinux meminfo_proc_show+0x5/0x568
10 #   meminfo_proc_show+0x5/0x568:
11 #   meminfo_proc_show at fs/proc/meminfo.c:27
12 #
13 # If the address is part of an inlined function, the full inline call chain is
14 # printed:
15 #
16 #   $ ./scripts/faddr2line ~/k/vmlinux native_write_msr+0x6/0x27
17 #   native_write_msr+0x6/0x27:
18 #   arch_static_branch at arch/x86/include/asm/msr.h:121
19 #    (inlined by) static_key_false at include/linux/jump_label.h:125
20 #    (inlined by) native_write_msr at arch/x86/include/asm/msr.h:125
21 #
22 # The function size after the '/' in the input is optional, but recommended.
23 # It's used to help disambiguate any duplicate symbol names, which can occur
24 # rarely.  If the size is omitted for a duplicate symbol then it's possible for
25 # multiple code sites to be printed:
26 #
27 #   $ ./scripts/faddr2line ~/k/vmlinux raw_ioctl+0x5
28 #   raw_ioctl+0x5/0x20:
29 #   raw_ioctl at drivers/char/raw.c:122
30 #
31 #   raw_ioctl+0x5/0xb1:
32 #   raw_ioctl at net/ipv4/raw.c:876
33 #
34 # Multiple addresses can be specified on a single command line:
35 #
36 #   $ ./scripts/faddr2line ~/k/vmlinux type_show+0x10/45 free_reserved_area+0x90
37 #   type_show+0x10/0x2d:
38 #   type_show at drivers/video/backlight/backlight.c:213
39 #
40 #   free_reserved_area+0x90/0x123:
41 #   free_reserved_area at mm/page_alloc.c:6429 (discriminator 2)
42
43
44 set -o errexit
45 set -o nounset
46
47 usage() {
48         echo "usage: faddr2line [--list] <object file> <func+offset> <func+offset>..." >&2
49         exit 1
50 }
51
52 warn() {
53         echo "$1" >&2
54 }
55
56 die() {
57         echo "ERROR: $1" >&2
58         exit 1
59 }
60
61 UTIL_SUFFIX=""
62 if [[ "${LLVM:-}" == "" ]]; then
63         UTIL_PREFIX=${CROSS_COMPILE:-}
64 else
65         UTIL_PREFIX=llvm-
66
67         if [[ "${LLVM}" == *"/" ]]; then
68                 UTIL_PREFIX=${LLVM}${UTIL_PREFIX}
69         elif [[ "${LLVM}" == "-"* ]]; then
70                 UTIL_SUFFIX=${LLVM}
71         fi
72 fi
73
74 READELF="${UTIL_PREFIX}readelf${UTIL_SUFFIX}"
75 ADDR2LINE="${UTIL_PREFIX}addr2line${UTIL_SUFFIX}"
76 AWK="awk"
77 GREP="grep"
78
79 command -v ${AWK} >/dev/null 2>&1 || die "${AWK} isn't installed"
80 command -v ${READELF} >/dev/null 2>&1 || die "${READELF} isn't installed"
81 command -v ${ADDR2LINE} >/dev/null 2>&1 || die "${ADDR2LINE} isn't installed"
82
83 # Try to figure out the source directory prefix so we can remove it from the
84 # addr2line output.  HACK ALERT: This assumes that start_kernel() is in
85 # init/main.c!  This only works for vmlinux.  Otherwise it falls back to
86 # printing the absolute path.
87 find_dir_prefix() {
88         local start_kernel_addr=$(echo "${ELF_SYMS}" | sed 's/\[.*\]//' |
89                 ${AWK} '$8 == "start_kernel" {printf "0x%s", $2}')
90         [[ -z $start_kernel_addr ]] && return
91
92         run_addr2line ${start_kernel_addr} ""
93         [[ -z $ADDR2LINE_OUT ]] && return
94
95         local file_line=${ADDR2LINE_OUT#* at }
96         if [[ -z $file_line ]] || [[ $file_line = $ADDR2LINE_OUT ]]; then
97                 return
98         fi
99         local prefix=${file_line%init/main.c:*}
100         if [[ -z $prefix ]] || [[ $prefix = $file_line ]]; then
101                 return
102         fi
103
104         DIR_PREFIX=$prefix
105         return 0
106 }
107
108 run_readelf() {
109         local objfile=$1
110         local out=$(${READELF} --file-header --section-headers --symbols --wide $objfile)
111
112         # This assumes that readelf first prints the file header, then the section headers, then the symbols.
113         # Note: It seems that GNU readelf does not prefix section headers with the "There are X section headers"
114         # line when multiple options are given, so let's also match with the "Section Headers:" line.
115         ELF_FILEHEADER=$(echo "${out}" | sed -n '/There are [0-9]* section headers, starting at offset\|Section Headers:/q;p')
116         ELF_SECHEADERS=$(echo "${out}" | sed -n '/There are [0-9]* section headers, starting at offset\|Section Headers:/,$p' | sed -n '/Symbol table .* contains [0-9]* entries:/q;p')
117         ELF_SYMS=$(echo "${out}" | sed -n '/Symbol table .* contains [0-9]* entries:/,$p')
118 }
119
120 check_vmlinux() {
121         # vmlinux uses absolute addresses in the section table rather than
122         # section offsets.
123         IS_VMLINUX=0
124         local file_type=$(echo "${ELF_FILEHEADER}" |
125                 ${AWK} '$1 == "Type:" { print $2; exit }')
126         if [[ $file_type = "EXEC" ]] || [[ $file_type == "DYN" ]]; then
127                 IS_VMLINUX=1
128         fi
129 }
130
131 init_addr2line() {
132         local objfile=$1
133
134         check_vmlinux
135
136         ADDR2LINE_ARGS="--functions --pretty-print --inlines --addresses --exe=$objfile"
137         if [[ $IS_VMLINUX = 1 ]]; then
138                 # If the executable file is vmlinux, we don't pass section names to
139                 # addr2line, so we can launch it now as a single long-running process.
140                 coproc ADDR2LINE_PROC (${ADDR2LINE} ${ADDR2LINE_ARGS})
141         fi
142 }
143
144 run_addr2line() {
145         local addr=$1
146         local sec_name=$2
147
148         if [[ $IS_VMLINUX = 1 ]]; then
149                 # We send to the addr2line process: (1) the address, then (2) a sentinel
150                 # value, i.e., something that can't be interpreted as a valid address
151                 # (i.e., ","). This causes addr2line to write out: (1) the answer for
152                 # our address, then (2) either "?? ??:0" or "0x0...0: ..." (if
153                 # using binutils' addr2line), or "," (if using LLVM's addr2line).
154                 echo ${addr} >& "${ADDR2LINE_PROC[1]}"
155                 echo "," >& "${ADDR2LINE_PROC[1]}"
156                 local first_line
157                 read -r first_line <& "${ADDR2LINE_PROC[0]}"
158                 ADDR2LINE_OUT=$(echo "${first_line}" | sed 's/^0x[0-9a-fA-F]*: //')
159                 while read -r line <& "${ADDR2LINE_PROC[0]}"; do
160                         if [[ "$line" == "?? ??:0" ]] || [[ "$line" == "," ]] || [[ $(echo "$line" | ${GREP} "^0x00*: ") ]]; then
161                                 break
162                         fi
163                         ADDR2LINE_OUT+=$'\n'$(echo "$line" | sed 's/^0x[0-9a-fA-F]*: //')
164                 done
165         else
166                 # Run addr2line as a single invocation.
167                 local sec_arg
168                 [[ -z $sec_name ]] && sec_arg="" || sec_arg="--section=${sec_name}"
169                 ADDR2LINE_OUT=$(${ADDR2LINE} ${ADDR2LINE_ARGS} ${sec_arg} ${addr} | sed 's/^0x[0-9a-fA-F]*: //')
170         fi
171 }
172
173 __faddr2line() {
174         local objfile=$1
175         local func_addr=$2
176         local dir_prefix=$3
177         local print_warnings=$4
178
179         local sym_name=${func_addr%+*}
180         local func_offset=${func_addr#*+}
181         func_offset=${func_offset%/*}
182         local user_size=
183         [[ $func_addr =~ "/" ]] && user_size=${func_addr#*/}
184
185         if [[ -z $sym_name ]] || [[ -z $func_offset ]] || [[ $sym_name = $func_addr ]]; then
186                 warn "bad func+offset $func_addr"
187                 DONE=1
188                 return
189         fi
190
191         # Go through each of the object's symbols which match the func name.
192         # In rare cases there might be duplicates, in which case we print all
193         # matches.
194         while read line; do
195                 local fields=($line)
196                 local sym_addr=0x${fields[1]}
197                 local sym_elf_size=${fields[2]}
198                 local sym_sec=${fields[6]}
199                 local sec_size
200                 local sec_name
201
202                 # Get the section size:
203                 sec_size=$(echo "${ELF_SECHEADERS}" | sed 's/\[ /\[/' |
204                         ${AWK} -v sec=$sym_sec '$1 == "[" sec "]" { print "0x" $6; exit }')
205
206                 if [[ -z $sec_size ]]; then
207                         warn "bad section size: section: $sym_sec"
208                         DONE=1
209                         return
210                 fi
211
212                 # Get the section name:
213                 sec_name=$(echo "${ELF_SECHEADERS}" | sed 's/\[ /\[/' |
214                         ${AWK} -v sec=$sym_sec '$1 == "[" sec "]" { print $2; exit }')
215
216                 if [[ -z $sec_name ]]; then
217                         warn "bad section name: section: $sym_sec"
218                         DONE=1
219                         return
220                 fi
221
222                 # Calculate the symbol size.
223                 #
224                 # Unfortunately we can't use the ELF size, because kallsyms
225                 # also includes the padding bytes in its size calculation.  For
226                 # kallsyms, the size calculation is the distance between the
227                 # symbol and the next symbol in a sorted list.
228                 local sym_size
229                 local cur_sym_addr
230                 local found=0
231                 while read line; do
232                         local fields=($line)
233                         cur_sym_addr=0x${fields[1]}
234                         local cur_sym_elf_size=${fields[2]}
235                         local cur_sym_name=${fields[7]:-}
236
237                         # is_mapping_symbol(cur_sym_name)
238                         if [[ ${cur_sym_name} =~ ^(\.L|L0|\$) ]]; then
239                                 continue
240                         fi
241
242                         if [[ $cur_sym_addr = $sym_addr ]] &&
243                            [[ $cur_sym_elf_size = $sym_elf_size ]] &&
244                            [[ $cur_sym_name = $sym_name ]]; then
245                                 found=1
246                                 continue
247                         fi
248
249                         if [[ $found = 1 ]]; then
250                                 sym_size=$(($cur_sym_addr - $sym_addr))
251                                 [[ $sym_size -lt $sym_elf_size ]] && continue;
252                                 found=2
253                                 break
254                         fi
255                 done < <(echo "${ELF_SYMS}" | sed 's/\[.*\]//' | ${AWK} -v sec=$sym_sec '$7 == sec' | sort --key=2 | ${GREP} -A1 --no-group-separator " ${sym_name}$")
256
257                 if [[ $found = 0 ]]; then
258                         warn "can't find symbol: sym_name: $sym_name sym_sec: $sym_sec sym_addr: $sym_addr sym_elf_size: $sym_elf_size"
259                         DONE=1
260                         return
261                 fi
262
263                 # If nothing was found after the symbol, assume it's the last
264                 # symbol in the section.
265                 [[ $found = 1 ]] && sym_size=$(($sec_size - $sym_addr))
266
267                 if [[ -z $sym_size ]] || [[ $sym_size -le 0 ]]; then
268                         warn "bad symbol size: sym_addr: $sym_addr cur_sym_addr: $cur_sym_addr"
269                         DONE=1
270                         return
271                 fi
272
273                 sym_size=0x$(printf %x $sym_size)
274
275                 # Calculate the address from user-supplied offset:
276                 local addr=$(($sym_addr + $func_offset))
277                 if [[ -z $addr ]] || [[ $addr = 0 ]]; then
278                         warn "bad address: $sym_addr + $func_offset"
279                         DONE=1
280                         return
281                 fi
282                 addr=0x$(printf %x $addr)
283
284                 # If the user provided a size, make sure it matches the symbol's size:
285                 if [[ -n $user_size ]] && [[ $user_size -ne $sym_size ]]; then
286                         [[ $print_warnings = 1 ]] &&
287                                 echo "skipping $sym_name address at $addr due to size mismatch ($user_size != $sym_size)"
288                         continue;
289                 fi
290
291                 # Make sure the provided offset is within the symbol's range:
292                 if [[ $func_offset -gt $sym_size ]]; then
293                         [[ $print_warnings = 1 ]] &&
294                                 echo "skipping $sym_name address at $addr due to size mismatch ($func_offset > $sym_size)"
295                         continue
296                 fi
297
298                 # In case of duplicates or multiple addresses specified on the
299                 # cmdline, separate multiple entries with a blank line:
300                 [[ $FIRST = 0 ]] && echo
301                 FIRST=0
302
303                 echo "$sym_name+$func_offset/$sym_size:"
304
305                 # Pass section address to addr2line and strip absolute paths
306                 # from the output:
307                 run_addr2line $addr $sec_name
308                 local output=$(echo "${ADDR2LINE_OUT}" | sed "s; $dir_prefix\(\./\)*; ;")
309                 [[ -z $output ]] && continue
310
311                 # Default output (non --list):
312                 if [[ $LIST = 0 ]]; then
313                         echo "$output" | while read -r line
314                         do
315                                 echo $line
316                         done
317                         DONE=1;
318                         continue
319                 fi
320
321                 # For --list, show each line with its corresponding source code:
322                 echo "$output" | while read -r line
323                 do
324                         echo
325                         echo $line
326                         n=$(echo $line | sed 's/.*:\([0-9]\+\).*/\1/g')
327                         n1=$[$n-5]
328                         n2=$[$n+5]
329                         f=$(echo $line | sed 's/.*at \(.\+\):.*/\1/g')
330                         ${AWK} 'NR>=strtonum("'$n1'") && NR<=strtonum("'$n2'") { if (NR=='$n') printf(">%d<", NR); else printf(" %d ", NR); printf("\t%s\n", $0)}' $f
331                 done
332
333                 DONE=1
334
335         done < <(echo "${ELF_SYMS}" | sed 's/\[.*\]//' | ${AWK} -v fn=$sym_name '$8 == fn')
336 }
337
338 [[ $# -lt 2 ]] && usage
339
340 objfile=$1
341
342 LIST=0
343 [[ "$objfile" == "--list" ]] && LIST=1 && shift && objfile=$1
344
345 [[ ! -f $objfile ]] && die "can't find objfile $objfile"
346 shift
347
348 run_readelf $objfile
349
350 echo "${ELF_SECHEADERS}" | ${GREP} -q '\.debug_info' || die "CONFIG_DEBUG_INFO not enabled"
351
352 init_addr2line $objfile
353
354 DIR_PREFIX=supercalifragilisticexpialidocious
355 find_dir_prefix
356
357 FIRST=1
358 while [[ $# -gt 0 ]]; do
359         func_addr=$1
360         shift
361
362         # print any matches found
363         DONE=0
364         __faddr2line $objfile $func_addr $DIR_PREFIX 0
365
366         # if no match was found, print warnings
367         if [[ $DONE = 0 ]]; then
368                 __faddr2line $objfile $func_addr $DIR_PREFIX 1
369                 warn "no match for $func_addr"
370         fi
371 done